﻿Imports System.ComponentModel
Imports System.Drawing
Namespace System.Windows.Forms

   Public Class DGVDataPaintEventArgs(Of T As DataRow) : Inherits EventArgs
      Public Event Painting(ByVal e As DGVDataPaintEventArgs(Of T))

      Public Pevent As DataGridViewCellPaintingEventArgs
      Public Column As DataGridViewColumn
      Public Graphics As Graphics
      Public Row As T
      Public ReadOnly Brush As New SolidBrush(Color.AliceBlue)
      Public Grid As DataGridView

      Public Sub SetGrid(ByVal grid As DataGridView)
         Me.Grid = grid
         AddHandler grid.CellPainting, AddressOf Grid_CellPainting
      End Sub

      Public Sub PaintBackground(Optional ByVal color As Color = Nothing, _
            Optional ByVal selectionBackColor As Color = Nothing)
         With Pevent
            Dim selected = 0 <> (.State And DataGridViewElementStates.Selected)
            If selected Then color = selectionBackColor
            If color = Drawing.Color.Empty Then
               .PaintBackground(.CellBounds, selected)
            Else
               Brush.Color = color
               Graphics.FillRectangle(Brush, .CellBounds)
            End If
         End With
      End Sub

      Public Sub PaintContent()
         With Pevent
            .PaintContent(.CellBounds)
         End With
      End Sub

      Public Property Handled As Boolean
         Get
            Return Pevent.Handled
         End Get
         Set(ByVal value As Boolean)
            Pevent.Handled = value
         End Set
      End Property
      Public ReadOnly Property CellBounds As Rectangle
         Get
            Return Pevent.CellBounds
         End Get
      End Property
      Public ReadOnly Property Selected As Boolean
         Get
            Return 0 <> (Pevent.State And DataGridViewElementStates.Selected)
         End Get
      End Property

      Private Sub Grid_CellPainting(ByVal sender As Object, ByVal e As DataGridViewCellPaintingEventArgs)
         If e.ColumnIndex < 0 OrElse e.RowIndex < 0 Then Return
         If e.RowIndex > Grid.RowCount - If(Grid.AllowUserToAddRows, 2, 1) Then Return
         Column = Grid.Columns(e.ColumnIndex)
         Row = DirectCast(DirectCast(Grid.Rows(e.RowIndex).DataBoundItem, DataRowView).Row, T)
         Pevent = e
         Graphics = e.Graphics
         RaiseEvent Painting(Me)
      End Sub

   End Class

End Namespace
