﻿Imports System.Runtime.CompilerServices
Imports System.Diagnostics
Imports System.Runtime.InteropServices

Namespace System

   Public Module ByteArrayX
      ''' <summary>note: to convert primitive data better use BitConverter</summary>
      <Extension()> _
      Public Sub ReadTo(Of T)(ByVal Subj As Byte(), ByVal Offs As Integer, ByVal Targets As T())
         Dim size = Marshal.SizeOf(GetType(T))
         Buffer.BlockCopy(Subj, Offs, Targets, 0, Targets.Length * size)
      End Sub

      ''' <summary>note: to convert primitive data better use BitConverter</summary>
      <Extension()> _
      Public Function Read(Of T)(ByVal Subj As Byte(), ByVal Offs As Integer) As T
         Dim size = Marshal.SizeOf(GetType(T))
         Dim Targets(0) As T
         Buffer.BlockCopy(Subj, Offs * size, Targets, 0, size)
         Return Targets(0)
      End Function

      ''' <summary>
      ''' konvertiert ein 4-byte-Array nach Int64. Auf dem Int64 können arithmetische Operationen angewendet werden, die bei einer Konvertierung nach Int32 zu Überläufen führten.
      ''' </summary>
      <Extension()> _
      Public Function ToInt64(ByVal bytes As Byte()) As Int64
         Dim b2(7) As Byte
         If BitConverter.IsLittleEndian Then
            Buffer.BlockCopy(bytes, 0, b2, 8 - bytes.Length, bytes.Length)
            Array.Reverse(b2)
         Else
            Throw New NotImplementedException( _
               "auf einem BigEndian-System ist diese Methode noch nicht getestet")
            Buffer.BlockCopy(bytes, 0, b2, 0, bytes.Length)
         End If
         Dim res(0) As Int64
         Buffer.BlockCopy(b2, 0, res, 0, 8)
         Return res(0)
      End Function

      ''' <summary>gibt die Byte-Darstellung eines Int32 zurück. Überlauf-Bytes werden ignoriert</summary>
      <Extension()> _
      Public Function ToInt32Bytes(ByVal i64 As Int64) As Byte()
         ReDim ToInt32Bytes(3)
         Dim b2 = BitConverter.GetBytes(i64)
         If BitConverter.IsLittleEndian Then
            Array.Reverse(b2)
            Buffer.BlockCopy(b2, 4, ToInt32Bytes, 0, 4)
         Else
            Throw New NotImplementedException( _
               "auf einem BigEndian-System ist diese Methode noch nicht getestet")
            Buffer.BlockCopy(b2, 0, ToInt32Bytes, 0, 4)
         End If
      End Function
   End Module
End Namespace
