﻿Namespace System.ComponentModel

   Public Class ChangeNotifier : Implements INotifyPropertyChanged

#Region "INotifyPropertyChanged"
      Public Event PropertyChanged(ByVal sender As Object, ByVal e As PropertyChangedEventArgs) Implements INotifyPropertyChanged.PropertyChanged

      Protected Sub OnPropertyChanged(ByVal propName As String)
         RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propName))
      End Sub

      Protected Function SetProperty(Of T)(ByVal propName As String, ByRef backingField As T, ByVal value As T) As Boolean
         If Object.Equals(backingField, value) Then Return False
         backingField = value
         OnPropertyChanged(propName)
         Return True
      End Function
#End Region 'INotifyPropertyChanged

   End Class

End Namespace
