﻿Namespace System.IO

   Public Class Logger2 : Inherits StreamWriter
      Public Sub New(ByVal file As String, Optional ByVal append As Boolean = False)
         MyBase.New(file, append)
         Log("logging started")
      End Sub
      Public Sub Log(ByVal ParamArray data As Object())
         MyBase.Write(String.Format("{0:yyyy-M-d H:mm:ss,fff}: ", Now))
         MyBase.WriteLine(String.Join(" ", data))
      End Sub
   End Class

   Public NotInheritable Class Logger : Implements IDisposable

      Private _File As FileInfo

      Public Sub New(ByVal file As String)
         _File = New FileInfo(file)
         If _File.Exists Then _File.Delete()
         Log("logging started")
      End Sub
      Public Sub Log(ByVal ParamArray data As Object())
         Using _Writer As New StreamWriter(_File.FullName, True)
            _Writer.Write(String.Format("{0:yyyy-M-d H:mm:ss,fff}: ", Now))
            _Writer.WriteLine(String.Join(" ", data))
         End Using
      End Sub

      Public Sub Dispose() Implements IDisposable.Dispose
      End Sub

   End Class


End Namespace